/* 	$Id: twoport.c,v 1.17 2007/09/01 08:52:04 cgm22 Exp cgm22 $	 */

/* 	Derived from evolvebistableK.c,v 1.2 2007/04/23 01:07:59 cgm22 Exp cgm22 $	 */

/* 	Derived from evolvebistable.c,v 1.11 2007/04/21 22:09:34 cgm22 Exp cgm22 $	 */

/* 	Derived from AdSys evolvegate.c,v 1.4 2007/04/10 21:46:28 cherry Exp cherry $	 */

/* 	Derived from Alife evolvegate.c,v 1.9 2007/01/11 15:42:40 cherry Exp cherry $	 */


#include <assert.h>
#include <errno.h>
#include <malloc.h>
#include <math.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>

#include <sys/time.h>
#include <sys/wait.h>

#include "unitor.h"

#define genedecode(gene) (grayToBinary8bit(gene))

int gen_unitor(int, int, int, int, int, int, int, int, char *, int *);
int gen_netlist(char *, char *, char *, int *, int);

int rpool[] = { LUTSHORTRES, 
		10, 
		20,
		40,
		80,
		160,
		320,
		640,
		2000, 
		8000,
		16000,
		32000,
		64000,
		128000,
		256000,
		LUTSKIPRES 
};

float cpool[] = { LUTSKIPCAP,
		  5.1e-8,
		  1.1e-7,
		  5.1e-7,
		  1.1e-6,
		  5.1e-6,
		  1.1e-5,
		  5.1e-5,
		  1.1e-4,
		  5.1e-4,
		  1.1e-3,
		  5.1e-3,
		  1.1e-2,
		  5.1e-2,
		  1.1e-1,
		  LUTSHORTCAP
};

float lpool[] = { LUTSHORTIND,
		  1.1e-2,
		  2.1e-2,
		  4.1e-2,
		  8.1e-2,
		  1.1e-1,
		  2.1e-1,
		  4.1e-1,
		  8.1e-1,
		  1.1,
		  2.1,
		  4.1,
		  8.1,
		  10.1,
		  12.1,
		  LUTSKIPIND 
};

void catch_INT(int);

char logfilename[255];

FILE *fd_logfile;

int MAXDEVSLOG2 = 0; /* log2(MAXDEVS): initialised in main(). see below */
int MAXNODESLOG2 = 0; /* log2(MAXNODES): initialised in main(). see below */
int GENELENGTH = 0;  /* In bits. 3 elements per unitor. 1 voutnode extra.*/
int GENELENGTHB = 0; /* Fit genelength in bytes. */

main()
{

	int i;
	struct timeval tv;


	/* every individual in the population has the following
	 * properties: fitness, the timestamp of the instant it was
	 * born, the lineage stamp, or the generation number it was
	 * born. 
	 */

	float fitness[POPULATION];

	/* Assuming 64bits for the variable holding the timestamp in
	 * usec, the largest 64bit decimal number has 21digits. For
	 * two numbers: 42 digits. 
	 */

	char timestamp[POPULATION][42];
	int lineage[POPULATION];

	char *pop[POPULATION];

 	char *genotype = malloc(GENELENGTHB);
	allele_t allele;

	/* Install signal handlers */
	signal(SIGINT, catch_INT);

	/* Initialise MAXDEVSLOG2 */
	int maxdevs = MAXDEVS;
	MAXDEVSLOG2 = 0;
	do MAXDEVSLOG2++; while(maxdevs >>= 1);
	printf("MAXDEVS: %d, MAXDEVSLOG2: %d\n", MAXDEVS, MAXDEVSLOG2);

	/* Initialise MAXNODESLOG2 */
	int maxnodes = MAXNODES;
	MAXNODESLOG2 = 0;
	do MAXNODESLOG2++; while(maxnodes >>= 1);
	printf("MAXNODES: %d, MAXNODESLOG2: %d\n", MAXNODES, MAXNODESLOG2);

	GENELENGTH  = 8 * (MAXDEVS * 3) + MAXDEVSLOG2;   /* In bits. 3 elements per unitor. 1 voutnode extra.*/
	GENELENGTHB = (roundup(GENELENGTH, 8) / 8);	/* Fit genelength in bytes. */


	printf("GENELENGTHB = %d\n", GENELENGTHB);
	/* Initialise pop array of pointers */

	pop[0] = malloc(POPULATION * GENELENGTHB);

	for(i = 1;i < POPULATION;i++)
		pop[i] = pop[i - 1] + GENELENGTHB;
	
	sprintf(logfilename, "%s-%d.log", LOGFILEPREFIX, getpid());

	/* Open the log file for dumping log data */
	fd_logfile = fopen(logfilename, "w");

	/* Setup random number generator */

	gettimeofday(&tv, NULL);
	srand48(tv.tv_usec);

	/* initialise fitness array to 0 */
	
	bzero(fitness, POPULATION * sizeof(typeof(float)));
	bzero(lineage, POPULATION * sizeof(typeof(int)));

	ga(pop, fitness, lineage, timestamp, genotype, lifecycle);

	free(pop[0]);
	free(genotype);

	printf("Writing log to %s\n", logfilename);
	fclose(fd_logfile);

}

/* Writes netlist string into the given buffer *netlist 
 * of size strz
 * Returns the number of bytes written _excluding_ trailing '\0'.
 * or -1 on error
 */

int
gen_netlist(char *timestamp, char *genestring, char *netlist, int *numcompsp, int strsz)
{

	char *tmpp = netlist;
	int unumcomps = 0; /* Number of components per unitor */

	/* Increments geneptr if necessary. 
	 * Please don't touch nibble.  
	 */

	int nibble = 0;			/* A bit "pointer" */
	allele_t gene;
	allele_t *geneptr = genestring;	/* The geneptr points to the
					 * genestring and moves along it as it
					 * is processed by various
					 * "morphogenerators" 
					 */



	unsigned int reslutp, caplutp, indlutp;	/* Indices into LUTs */

	unsigned int resness, capness, indness; /* Degrees of device "ness" */

	unsigned int voutnode;

	int bytes;

	int i, j;

	assert(*numcompsp == 0);

	if (strsz < NETLISTSZ) return -1;

	/*****      Generate Circuit Netlist *****/

	netlist += sprintf(netlist, "%s%s%s", "*<---Individual number-*", timestamp, " *--->\n\n");
	/* Input at Node 1 XXX: Fixme. Make this more flexible. (evolvable ?) */
	netlist += sprintf(netlist, "%s",
			   "VS	1	0	AC	1	SIN(0	1	2KHZ)\n");


	/* Fetch the Vout Node */
	gene = getgeneplusplus(&geneptr, &nibble, MAXNODESLOG2); 
	voutnode = voutnodedecode(gene);
	if (!(voutnode <= MAXNODES)) {printf("voutnode: %d\n", voutnode); exit(0);}
	assert(voutnode <= MAXNODES);

	printf("voutnode: %d\n", voutnode); 

	if (voutnode == 0 || voutnode == 1) /* Don't need ground or Vin */
		return -1; 
			
	for (i = 0; i < MAXNODES; i++) {
		for (j = i + 1;j < MAXNODES; j++) {
			
			unumcomps = 0;
			
			/* Decode resistance */
			gene = getgeneplusplus(&geneptr, &nibble, 4); 
			reslutp = genedecode(gene);
			if(!(reslutp < 16)) printf("reslutp: %d\n", reslutp);
			assert(reslutp < 16);

			gene = getgeneplusplus(&geneptr, &nibble, 4);
			resness = genedecode(gene);
			assert(resness < 16);
			if (resness == 0xf || resness == 0) reslutp = resness;


			/* Decode Capacitance */
			gene = getgeneplusplus(&geneptr, &nibble, 4); 
			caplutp = genedecode(gene);
			if(!(caplutp < 16)) printf("caplutp: %d\n", caplutp);
			assert(caplutp < 16);

			gene = getgeneplusplus(&geneptr, &nibble, 4);
			capness = genedecode(gene);
			assert(capness < 16);
			if (capness == 0 || capness == 0xf) caplutp = capness;


			/* Decode Inductance */
			gene = getgeneplusplus(&geneptr, &nibble, 4); 
			indlutp = genedecode(gene);
			if(!(indlutp < 16)) printf("indlutp: %d\n", indlutp);
			assert(indlutp < 16);
			

			gene = getgeneplusplus(&geneptr, &nibble, 4);
			indness = genedecode(gene);
			assert(indness < 16);
			if (indness == 0 || indness == 0xf) indlutp = indness;


			if (!(rpool[reslutp] == LUTSKIPRES) || ((cpool[caplutp] == LUTSKIPCAP) && (lpool[indlutp] == LUTSKIPIND))) {
				
				/* Write out component and component behaviour */
				netlist += sprintf(netlist, "X%d%d %d %d U%d%d\n", i, j, i, j, i, j);
				netlist += gen_unitor(resness, capness, indness, reslutp, caplutp, indlutp, i, j, netlist, &unumcomps);
				*numcompsp += unumcomps; /* Accumulate numcomps in the unitor */
			} else {

				/* Encourage parsimony ? */
				*numcompsp += 100;
			}
			
		}
	}

	netlist += sprintf(netlist, "%s", ".OPTIONS NOPAGE\n");
	netlist += sprintf(netlist, "%s", ".AC 	DEC 	5 10 1MEG\n");

	netlist += sprintf(netlist, "%s%d%s", ".PRINT  AC VM(", voutnode, ")\n"); 

	netlist += sprintf(netlist, "%s", ".END\n");
	return (netlist - tmpp);
}



/* Returns number of bytes sprintf()ed _excluding_ trailing '\0'. */
int gen_unitor(int resness, int capness, int indness, int reslutp, int caplutp, int indlutp, int n1, int n2, char *buf, int *numcomps)
{


	unsigned int res;
	float ind, cap;

	char *tmpp = buf;


	res = rpool[reslutp];
	cap = cpool[caplutp];
	ind = lpool[indlutp];


	if ((res == LUTSHORTRES)) {

		if ((cap == LUTSHORTCAP) || (ind == LUTSHORTIND)) {
			/* unitor is a short circuit */
			buf += sprintf(buf, ".SUBCKT U%d%d 1 3\n", n1, n2);
			buf += sprintf(buf, "R%d%d 1 3 %u\n", n1, n2, res);
			buf += sprintf(buf, "%s", ".ENDS\n");
			*numcomps = 0;	/* short circuit == resistor of 0 ohms 
						 * XXX: Could also be capacitor of inf. cap. 
						 */

			return(buf - tmpp);	/* Number of bytes sprintf()ed */
		}


			
		if (cap == LUTSKIPCAP) {
			/* Unitor is an inductor */
			buf += sprintf(buf, ".SUBCKT U%d%d 1 3\n", n1, n2);
			buf += sprintf(buf, "L%d%d 1 3 %e\n", n1, n2, ind);
			buf += sprintf(buf, "%s", ".ENDS\n");
			*numcomps = indness * 100 / 15;	/* Inductor */
			return(buf - tmpp);	/* Number of bytes sprintf()ed */
		}

		if (ind == LUTSKIPIND) {
			/* Unitor is a capacitor */
			buf += sprintf(buf, ".SUBCKT U%d%d 1 3\n", n1, n2);
			buf += sprintf(buf, "C%d%d 1 3 %e\n", n1, n2, cap);
			buf += sprintf(buf, "%s", ".ENDS\n");
			*numcomps = capness * 100 / 15;	/* Capacitor */
			return(buf - tmpp);	/* Number of bytes sprintf()ed */
			
		}
		
		/* Unitor is LC */
		buf += sprintf(buf, ".SUBCKT U%d%d 1 3\n", n1, n2);
		buf += sprintf(buf, "L%d%d 1 3 %e\n", n1, n2, ind);
		buf += sprintf(buf, "C%d%d 1 3 %e\n", n1, n2, cap);
		buf += sprintf(buf, "%s", ".ENDS\n");
		*numcomps = (((capness > indness) ? capness : indness) * 100 / (capness + indness))/2;
		return(buf - tmpp);	/* Number of bytes sprintf()ed */

	}
	else { /* res == valid resistance values */

		if ((cap == LUTSHORTCAP) || (ind == LUTSHORTIND)) {
			/* unitor is a resistor (5 cases out of 27) */
			buf += sprintf(buf, ".SUBCKT U%d%d 1 3\n", n1, n2);
			buf += sprintf(buf, "R%d%d 1 3 %u\n", n1, n2, res);
			buf += sprintf(buf, "%s", ".ENDS\n");
			*numcomps = resness * 100 / 15;	/* Resistor */
			return(buf - tmpp);	/* Number of bytes sprintf()ed */
		}

		if (cap == LUTSKIPCAP) {
			/* Unitor is an RL segment */
			buf += sprintf(buf, ".SUBCKT U%d%d 1 3\n", n1, n2);
			buf += sprintf(buf, "R%d%d 1 2 %u\n", n1, n2, res);
			buf += sprintf(buf, "L%d%d 2 3 %e\n", n1, n2, ind);
			buf += sprintf(buf, "%s", ".ENDS\n");
			*numcomps = (((resness > indness) ? resness : indness) * 100 / (resness + indness))/2;
			return(buf - tmpp);	/* Number of bytes sprintf()ed */
		}

		if (ind == LUTSKIPIND) {
			/* Unitor is an RC segment  */
			buf += sprintf(buf, ".SUBCKT U%d%d 1 3\n", n1, n2);
			buf += sprintf(buf, "R%d%d 1 2 %u\n", n1, n2, res);
			buf += sprintf(buf, "C%d%d 2 3 %e\n", n1, n2, cap);
			buf += sprintf(buf, "%s", ".ENDS\n");
			*numcomps = (((resness > capness) ? resness : capness) * 100 / (resness + capness))/2;
			return(buf - tmpp);	/* Number of bytes sprintf()ed */
		}
		
		/* Unitor is an RLC segment */
		buf += sprintf(buf, ".SUBCKT U%d%d 1 3\n", n1, n2);
		buf += sprintf(buf, "R%d%d 1 2 %u\n", n1, n2, res);
		buf += sprintf(buf, "C%d%d 2 3 %e\n", n1, n2, cap);
		buf += sprintf(buf, "L%d%d 2 3 %e\n", n1, n2, ind); 
		buf += sprintf(buf, "%s", ".ENDS\n");
		*numcomps = (((((resness > capness) ? resness : capness) > indness) ?
			((resness > capness) ? resness : capness) : indness) * 100/(resness + capness + indness))/4;
		return(buf - tmpp);	/* Number of bytes sprintf()ed */
	}

	assert(1); /* Why are we here ? */
	return 0;  /*NOTREACHED*/
}


